/*
Copyright (c) 2013, Linear Technology Corp.(LTC)
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this
   list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

The views and conclusions contained in the software and documentation are those
of the authors and should not be interpreted as representing official policies,
either expressed or implied, of Linear Technology Corp.
*/
//DC2289A Verilog code for LTC2380_24
//08/19/14
//REV1
//GMH
`timescale 1ns / 1ps
module RevA
(
	CNVST_33,
	CLK,
	CLKOUT,
	SDO,
	SCK_33,
	RD,
	BUSY_33,
	DB0,
	DB1,
	DB2,
	DB3,
	DB4,
	DB5,
	DB6,
	DB7,
	DB8,
	DB9,
	DB10,
	DB11,
	DB12,
	DB13,
	DB14,
	DB15,
	DB16,
	DB17,
	DB18,
	DB19,
	DB20,
	DB21,
	DB22,
	DB23,
	C8_C0,
	C9_C1,
	C10_C2,
	C11_C3,
	C12_C4,
	C13_C5,
	C14_C6,
	C15_C7,
	SEL_24_40L,
	DC2026_DETECT,
	SCK_IN,
	SCK_OUT,
	WRIN_I2C,
	SDI_I2C,
	SCK_I2C,
	AUX0_I2C,
	AUX1_I2C,
	AUX2_I2C,
	AUX3_I2C,
	AUXOUT,
	B24_40_I2C
);
output		CNVST_33;
input       DC2026_DETECT;							// 1=DC890, 0=DC2026
input			SEL_24_40L;								// 1=24 bits, 0=40 bits
input			CLK;
output		CLKOUT;
output		RD;
input			SDO;
output		SCK_33;
input       SCK_IN;
output     [6:0] SCK_OUT;
input			BUSY_33;
output			DB2;
output			DB3;
output			DB4;
output			DB5;
output			DB6;
output			DB7;
output			DB8;
output			DB9;
output			DB10;
output			DB14;
output			DB15;
output			DB16;
output			DB17;
output			DB0;
output			DB1;
output			DB11;
output			DB12;
output			DB13;
output         DB18;
output         DB19;
output			DB20;
output			DB21;
output			DB22;
output			DB23;
output			C8_C0;
output			C9_C1;
output			C10_C2;
output			C11_C3;
output			C12_C4;
output			C13_C5;
output			C14_C6;
output			C15_C7;
input				WRIN_I2C;
input				SDI_I2C;
input				SCK_I2C;
input				AUX0_I2C;
input				AUX1_I2C;
input				AUX2_I2C;
input				AUX3_I2C;
output			AUXOUT;
input				B24_40_I2C;
parameter 	CLR = 1'b0,
				SET = 1'b1,
				op = 1'b1,
				ip = 1'b0;	
wire master_clk;
wire [39:0] dout;
wire AUXOUT;
wire [15:0] sneaker_port_out;
wire [15:0] sneaker_port_count;
wire mosi;
wire aux0;
wire conv;
wire data_latch;
wire master_clk_0 /* synthesis keep */;											// added 02/25/09 to increase CNVSTL pulse to 20ns
wire master_clk_1 /* synthesis keep */;
wire master_clk_2 /* synthesis keep */;
wire master_clk_3 /* synthesis keep */;
wire master_clk_4 /* synthesis keep */;
wire master_clk_5 /* synthesis keep */;
wire master_clk_6 /* synthesis keep */;
wire master_clk_7 /* synthesis keep */;
wire master_clk_8 /* synthesis keep */;
wire master_clk_9 /* synthesis keep */;
wire master_out_0; //preserve
wire master_out_1; //preserve
wire master_out_2; //preserve
wire master_out_3; //preserve
wire master_out_4; //preserve
wire master_out_5; //preserve
wire master_out_6; //preserve
wire master_out_7; //preserve
wire master_out_8; //preserve
wire master_out_9; //preserve
wire master_clk_10 /* synthesis keep */;										// added 02/25/09
wire master_clk_11 /* synthesis keep */;
wire master_clk_12 /* synthesis keep */;
wire master_clk_13 /* synthesis keep */;
wire master_clk_14 /* synthesis keep */;
wire master_clk_15 /* synthesis keep */;
wire master_clk_16 /* synthesis keep */;
wire master_clk_17 /* synthesis keep */;
wire master_clk_18 /* synthesis keep */;
wire master_clk_19 /* synthesis keep */;
wire master_out_10; //preserve
wire master_out_11; //preserve
wire master_out_12; //preserve
wire master_out_13; //preserve
wire master_out_14; //preserve
wire master_out_15; //preserve
wire master_out_16; //preserve
wire master_out_17; //preserve
wire master_out_18; //preserve
wire master_out_19; //preserve
wire miso;
reg DB0;
reg DB1;
reg DB2;
reg DB3;
reg DB4;
reg DB5;														
reg DB6;
reg DB7;
reg DB8;
reg DB9;
reg DB10;
reg DB11;
reg DB12;
reg DB13;
reg DB14;
reg DB15;
reg DB16;
reg DB17;
reg DB18;
reg DB19;
reg DB20;
reg DB21;
reg DB22;
reg DB23;
reg C8_C0;
reg C9_C1;
reg C10_C2;
reg C11_C3;
reg C12_C4;
reg C13_C5;
reg C14_C6;
reg C15_C7;														
wire BUSY_33;
wire CLKOUT;
wire clkout_latch;																	//added 12/10/08
wire gated_sck;
wire SCK_IN;
wire [6:0]SCK_OUT;
wire sck;
wire B13;																			//not used
wire clk_gate;
//wire [6:0]clk_counter;
reg  d_latch_count;																//d_latch_count is for 40bit mode 0=DB23-DB0 and C15-C8, 1=C7-C0
reg  d_latch_gate;
//assign SCK_OUT = clk_counter;												//SCK_OUT is for debug only  was SCK_IN

//added 03/10/15
wire [15:0]master_count;
wire [15:0]master_reset;
reg reset_pulse;
assign master_count = 16'b0000000001100011;
wire data_latch_gate;
reg rp;
//end added 03/10/15
												
   always @(posedge data_latch )begin//	
	//	if (data_latch==1)begin///
			if (B24_40_I2C==1) begin////
					C15_C7 <= 1'b0;
					C14_C6 <= 1'b0;
					C13_C5 <= 1'b0;
					C12_C4 <= 1'b0;
					C11_C3 <= 1'b0;
					C10_C2 <= 1'b0;
					C9_C1 <= 1'b0;
					C8_C0 <= 1'b0;
					DB23 <= dout[23];
					DB22 <= dout[22];
					DB21 <= dout[21];
					DB20 <= dout[20];
				   DB19 <= dout[19];
				   DB18 <= dout[18];
					DB17 <= dout[17];
					DB16 <= dout[16];
					DB15 <= dout[15];
					DB14 <= dout[14];
					DB13 <= dout[13];
					DB12 <= dout[12];
					DB11 <= dout[11];
					DB10 <= dout[10];
					DB9 <= dout[9];
					DB8 <= dout[8];
					DB7 <= dout[7];
					DB6 <= dout[6];
					DB5 <= dout[5];
					DB4 <= dout[4];
					DB3 <= dout[3];
					DB2 <= dout[2];
					DB1 <= dout[1];
					DB0 <= dout[0];														// 24bit
			end////
			else begin////
			
			case (d_latch_count)
			
			1'b0: begin/////
					C15_C7 <= dout[7];
					C14_C6 <= dout[6];
					C13_C5 <= dout[5];
					C12_C4 <= dout[4];
					C11_C3 <= dout[3];
					C10_C2 <= dout[2];
					C9_C1 <= dout[1];
					C8_C0 <= dout[0];
					DB23 <= dout[39];
					DB22 <= dout[38];
					DB21 <= dout[37];
					DB20 <= dout[36];
				   DB19 <= dout[35];
				   DB18 <= dout[34];
					DB17 <= dout[33];
					DB16 <= dout[32];
					DB15 <= dout[31];
					DB14 <= dout[30];
					DB13 <= dout[29];
					DB12 <= dout[28];
					DB11 <= dout[27];
					DB10 <= dout[26];
					DB9 <= dout[25];
					DB8 <= dout[24];
					DB7 <= dout[23];
					DB6 <= dout[22];
					DB5 <= dout[21];
					DB4 <= dout[20];
					DB3 <= dout[19];
					DB2 <= dout[18];
					DB1 <= dout[17];
					DB0 <= dout[16];						
					d_latch_gate <=  1'b1;
					end/////
				1'b1: begin/////
					C15_C7 <= dout[15];
					C14_C6 <= dout[14];
					C13_C5 <= dout[13];
					C12_C4 <= dout[12];
					C11_C3 <= dout[11];
					C10_C2 <= dout[10];
					C9_C1 <= dout[9];
					C8_C0 <= dout[8];
					DB23 <= 1'b0;
					DB22 <= 1'b0;
					DB21 <= 1'b0;
					DB20 <= 1'b0;
				   DB19 <= 1'b0;
				   DB18 <= 1'b0;
					DB17 <= 1'b0;
					DB16 <= 1'b0;
					DB15 <= 1'b0;
					DB14 <= 1'b0;
					DB13 <= 1'b0;
					DB12 <= 1'b0;
					DB11 <= 1'b0;
					DB10 <= 1'b0;
					DB9 <= 1'b0;
					DB8 <= 1'b0;
					DB7 <= 1'b0;
					DB6 <= 1'b0;
					DB5 <= 1'b0;
					DB4 <= 1'b0;
					DB3 <= 1'b0;
					DB2 <= 1'b0;
					DB1 <= 1'b0;
					DB0 <= 1'b0;						// 40bit
					d_latch_gate <= 1'b0;
					end/////
			endcase
			end////
	//	end///
   end//
   
assign master_clk = CLK;						  								//02/24/09 was CLK   sck  output on serial_clk_out
assign master_clk_0 = ~master_clk;
assign master_clk_1 = ~master_clk_0;
assign master_clk_2 = ~master_clk_1;
assign master_clk_3 = ~master_clk_2;
assign master_clk_4 = ~master_clk_3;
assign master_clk_5 = ~master_clk_4;
assign master_clk_6 = ~master_clk_5;
assign master_clk_7 = ~master_clk_6;
assign master_clk_8 = ~master_clk_7;
assign master_clk_9 = ~master_clk_8;

assign master_clk_10 = ~master_clk_9;
assign master_clk_11 = ~master_clk_10;
assign master_clk_12 = ~master_clk_11;
assign master_clk_13 = ~master_clk_12;
assign master_clk_14 = ~master_clk_13;
assign master_clk_15 = ~master_clk_14;
assign master_clk_16 = ~master_clk_15;
assign master_clk_17 = ~master_clk_16;
assign master_clk_18 = ~master_clk_17;
assign master_clk_19 = ~master_clk_18;

assign miso = SDO;
assign CNVST_33 = ~conv ;					
assign RD = CLR ;



assign dlc = d_latch_count ;								
dff dff_latch(.d(!dlc),.clk(data_latch&!B24_40_I2C), .clrn(AUX0_I2C), .prn(1), .q(d_latch_count));				//03/09/15 .clrn was WRIN_I2C | d_latch_gate d_latch _count toggles on d_latch if 40bits, reset by WRIN_I2C



//dff dff_sck(.d (gate),.clk(master_clk_4), .clrn(1), .prn(1), .q(gated_sck));



assign CLKOUT =  data_latch ;											// was ~conv

dff dff1(.d(0), .clk(CLK), .clrn(1), .prn(~data_latch), .q(clkout_latch));
dff dffmc0(.d(0), .clk(master_clk_0), .clrn(1), .prn(1), .q(master_out_0));
dff dffmc1(.d(0), .clk(master_clk_1), .clrn(1), .prn(1), .q(master_out_1));
dff dffmc2(.d(0), .clk(master_clk_2), .clrn(1), .prn(1), .q(master_out_2));
dff dffmc3(.d(0), .clk(master_clk_3), .clrn(1), .prn(1), .q(master_out_3));
dff dffmc4(.d(0), .clk(master_clk_4), .clrn(1), .prn(1), .q(master_out_4));
dff dffmc5(.d(0), .clk(master_clk_5), .clrn(1), .prn(1), .q(master_out_5));
dff dffmc6(.d(0), .clk(master_clk_6), .clrn(1), .prn(1), .q(master_out_6));
dff dffmc7(.d(0), .clk(master_clk_7), .clrn(1), .prn(1), .q(master_out_7));
dff dffmc8(.d(0), .clk(master_clk_8), .clrn(1), .prn(1), .q(master_out_8));
dff dffmc9(.d(0), .clk(master_clk_9), .clrn(1), .prn(1), .q(master_out_9));

dff dffmc10(.d(0), .clk(master_clk_10), .clrn(1), .prn(1), .q(master_out_10));
dff dffmc11(.d(0), .clk(master_clk_11), .clrn(1), .prn(1), .q(master_out_11));
dff dffmc12(.d(0), .clk(master_clk_12), .clrn(1), .prn(1), .q(master_out_12));
dff dffmc13(.d(0), .clk(master_clk_13), .clrn(1), .prn(1), .q(master_out_13));
dff dffmc14(.d(0), .clk(master_clk_14), .clrn(1), .prn(1), .q(master_out_14));
dff dffmc15(.d(0), .clk(master_clk_15), .clrn(1), .prn(1), .q(master_out_15));
dff dffmc16(.d(0), .clk(master_clk_16), .clrn(1), .prn(1), .q(master_out_16));
dff dffmc17(.d(0), .clk(master_clk_17), .clrn(1), .prn(1), .q(master_out_17));
dff dffmc18(.d(0), .clk(master_clk_18), .clrn(1), .prn(1), .q(master_out_18));
dff dffmc19(.d(0), .clk(master_clk_19), .clrn(1), .prn(1), .q(master_out_19));


reg test;
assign AUXOUT = data_latch_gate;														// dummy output to suppress warnings

always @(posedge master_clk) begin
if (sneaker_port_count==0) test <= 1;
else test <=0;

end



serial_io io_2(.master_clk	(master_clk & reset_pulse),	   				//clk in from DCXXXX
			.mosi	 	   		(mosi), 	   	   									//sdi to DUT not used for all parts
			.miso	 	   		(miso), 	   	   									//sdo from DUT	
			.data_latch			(data_latch), 											//when to grab data
			.sck		 			(sck),		   										//sck to DUT 
			.conv	 	   		(conv),		   										//conv or conv_gate to DUT
			.aux0	 	   		(aux0), 		   										//aux signal not used for all parts
			.dout	 	   		(dout),													//parallel data bits
			.mcd					(master_clk_0 & reset_pulse),						//03/02/15 was master_clk_0
			.SEL_24_40L			(B24_40_I2C),											//select 24 or 40 bit format 
			.sneaker_port_count (sneaker_port_count),								//Current divide ratio count
			.WRIN_I2C			(WRIN_I2C  ),											//03/10/15 was WRIN_I2C | d_latch_gate )& AUX0_I2C    WRIN_I2C=0 set Write sneakerport, WRIN_I2C=1 read ADC
			.ONEWORD_TWOWORDL (AUX1_I2C),												//select 1word or 2word data format 1=1word, 0=2word 2word is necessary for >1.6Msps
			.SLOW					(AUX2_I2C),												//select SLOW if AUX2_I2C =0 SLOW and ONEWORD_TWOWORDL cannot both be low
			.mcd2					(master_clk_0 & reset_pulse),						//used to gate data_latch
			.clk_gate			(clk_gate),
			.bus					(SCK_OUT),
			.reset_pulse		(reset_pulse),
			.data_latch_gate	(data_latch_gate));
			
sneaker_port port1(.WRIN_I2C				(WRIN_I2C | data_latch_gate ), 	//03/10/15 was WRIN_I2C | d_latch_gate sneaker port update starts on falling edge of WRIN_I2C
					    .SDI_I2C				(SDI_I2C), 								//sneakerport serial data
					    .SCK_I2C				(SCK_I2C), 								//data clocked on rising edge of SCK_I2C
			          .sneaker_port_out	(sneaker_port_out)					//16-bit sneaker port data used to set divide ratio latched on rising edge of WRIN_I2C
						 );		

						
Counter counter1 (.aload					((rp)|(test & conv)),	//03/10/15 was WRIN_I2C& !AUX0_I2C |(test & conv) load sneaker_port_out into counter on rising edge of reset_pulse or after counter goes to 0
						.clock					(conv),									//decrement counter with each conv pulse
						.data						(sneaker_port_out),					//counter input from sneaker_port
						.q							(sneaker_port_count)					//counter output to serial_io
						);
						
						
						//Added 03/10/15
Counter counter2 (.aload					(!WRIN_I2C),								//rising edge of WRIN_I2C starts master reset counter
						.clock					(master_clk & (master_reset >1)),//master_clk is used to time delay
						.data						(master_count),						//master_count is delay amount
						.q							(master_reset)							//master_reset is signal to start activity
						);
						
		always @ (master_reset)	begin	
			if (master_reset >=3) begin
			reset_pulse <=0;
			rp<=0;
			end
		if (master_reset ==2) begin
		reset_pulse<= 0;
		rp<=1;
		end
		if (master_reset <=1) begin
		reset_pulse <=1;
		rp<=0;
		end		
		end
						//end added 03/10/15
		
		
 maxii_io
 d_bit_13(.datain  ( sck),												//serial_clk_out
         .oe  (DC2026_DETECT),										//DC2026_DETECT=1 SCK_33=sck & gated_sck, DC_2026_DETECT=0 SCK_33=HiZ
         .padio  (SCK_33),												//pin to SCK of LTC2380-24
         .combout (B13));												//
 defparam d_bit_13.operation_mode = "bidir";
 

endmodule
